package com.javaseleniumtemplate.flows;

import com.javaseleniumtemplate.pages.ConsumoPorServicoPage;

public class ConsumoPorServicoFlows {
    ConsumoPorServicoPage consumoporservicopage;

    public ConsumoPorServicoFlows() {
        consumoporservicopage = new ConsumoPorServicoPage();

    }

    public void navegarConsumoPorServico() {
        consumoporservicopage.navegaTelaConsumoPorServico();

    }

    public void realizarFiltro(String cdFilial,String tipoDeConsumo,String diaSemanaConsumo) {
        consumoporservicopage.realizarFiltro(cdFilial,tipoDeConsumo,diaSemanaConsumo);
    }

    public void adicionarProduto(String CDPRODUTO, String QTDPRODUTO,String TIPOCONSUMO, String IDTPREQPROD, String CDPRODUTO_1, String QTDPRODUTO_1) {
        consumoporservicopage.adicionaProduto(CDPRODUTO, QTDPRODUTO,TIPOCONSUMO, IDTPREQPROD,CDPRODUTO_1,QTDPRODUTO);
    }

    public void adicionarNovoProduto(String CDPRODUTO, String QTDPRODUTO,String TIPOCONSUMO){
        consumoporservicopage.adicionaNovoProduto(CDPRODUTO,QTDPRODUTO,TIPOCONSUMO);
    }

    public String retornaMensagem() {
     return consumoporservicopage.confirmaCadastro();
    }

    public String retornaMensagem_2() {
        return consumoporservicopage.confirmaCadastro_2();
    }

    public void cadastraExcecao(String tipoDeConsumo,String CDPRODUTO, String QTDPRODUTO){
        consumoporservicopage.adicionaExcecao(tipoDeConsumo,CDPRODUTO,QTDPRODUTO);
    }

    public String validarCadastroProdutoExecao(){return consumoporservicopage.retornaProdutoExcecao();}

    public void editaExcecao(String tipoConsumoExecao){consumoporservicopage.edidaConsumodiaExcecao(tipoConsumoExecao);
    }

    public String msgEncontradaQtdConsumida(){return consumoporservicopage.msgEncontradaQuantidadeConsumida();}

    public String msgEncontradaCampoPontoEntrega(){return consumoporservicopage.msgEncontradaPontoEntrega();}

    public String msgEncontradaCozinhaCentralDistribuicao(){return consumoporservicopage.msgEncontradaCozinhaCentral();}

    public void apagaProdutoExcecao(String tipoConsumoExecao){
        consumoporservicopage.apagaExcecao(tipoConsumoExecao);
    }

    public String mensagemExclusao(){
        return consumoporservicopage.validaExclusao();
    }

    public void cadastraDiaSemConsumo(){
        consumoporservicopage.diaSemConsumo();
    }

    public void edicaoDiaSemConsumo(){
        consumoporservicopage.edicaoDiaSemConsumo();
    }

    public void apagaDiaSemConsumo(){
        consumoporservicopage.apagaDiaSemConsumo();
    }

    public void alterarConsumoDia(String TIPOCONSMO){
        consumoporservicopage.alteraConsumoDia(TIPOCONSMO);
    }

    public void apagarConsumo(){
        consumoporservicopage.excluirProdutos();
    }

    public void importaConsumo(String CDFILIAL, String CDSERVICO,String TIPOCONSUMO,String IDIMPORTACAO){
        consumoporservicopage.importarConsumo(CDFILIAL, CDSERVICO,TIPOCONSUMO,IDIMPORTACAO);

    }

    public String importacaoProdCanfora(){return consumoporservicopage.validaImportacaoProdCanfora();}

    public String importacaoProdTampa(){return consumoporservicopage.validaImportacaoProdTampa();}

    public String importacaoProdTampaFrasco(){return consumoporservicopage.validaImportacaoProdTampaFrasco();}

    public String importacaoProdOleo(){return consumoporservicopage.validaImportacaoProdOleo();}

    public String validandoImportacaoSobrepor(){return consumoporservicopage.validaImportacaoSobrepor();}

    public void exportarConsumo(String CDFILIAL, String CDSERVFILI){
        consumoporservicopage.exportaConsumo(CDFILIAL,CDSERVFILI);
    }

    public void substituirProduto(){
        consumoporservicopage.substituiProduto();
    }

    public void importarExcecao(String tipoConsumoImportacao, String dadosExistentes){
        consumoporservicopage.importaExcecao(tipoConsumoImportacao, dadosExistentes);
    }

    public String produtoImportacaoExecao(){return consumoporservicopage.retornaProdutoImportacaoExcecao();}

    public String retornaProdutoImportacao(){return consumoporservicopage.validaProdutoImportacao();}

    public void exportarExcecoesConsumo(String acaoDadosExistentes){
        consumoporservicopage.exportarExcecao(acaoDadosExistentes);
    }

    public String validaProdutoCloreto(){return consumoporservicopage.retornaProdutoCloretoSodio();}

    public String validaProdutoOleo(){return consumoporservicopage.retornaProdutoOleoCopaiba();}

    public String produtoExecao(){return consumoporservicopage.msgEncontradaProdExecao();}

    public void substituirProdutoExcecao(String CDPRODORIG, String CDPRODNOVO){
        consumoporservicopage.substituiProdutoExcecao(CDPRODORIG,CDPRODNOVO);
    }


}
