package com.javaseleniumtemplate.flows;

import com.javaseleniumtemplate.pages.ParametrosDePlanejamentoPage;

public class ParametrosDePlanejamentoFlows {

    ParametrosDePlanejamentoPage parametrosDePlanejamentoPage = new ParametrosDePlanejamentoPage();

    public void acessarTela(){parametrosDePlanejamentoPage.acessarTela();}

    public String validaTela(){return parametrosDePlanejamentoPage.validaAcessoTela();}

    public void editaPersonalizacao(){parametrosDePlanejamentoPage.editaPersonalizacao();}

    public void edicaoAbaCardapio(){parametrosDePlanejamentoPage.editarAbaCardapio();}

    public void calculoNdpcal(){parametrosDePlanejamentoPage.calculoNdpcal();}

    public String validaExclusao(){return parametrosDePlanejamentoPage.validarExclusao();}

    public void cadastraAbaSafra(){parametrosDePlanejamentoPage.cadastraSafra();}

    public void editarSafra(){parametrosDePlanejamentoPage.editarSafra();}

    public void excluirSafra(){parametrosDePlanejamentoPage.apagarSafra();}

    public String validaEdicao(){return parametrosDePlanejamentoPage.validaEdicao();}

    public String validarEdicao(){return parametrosDePlanejamentoPage.validarEdicao();}

    public String validaCadastro(){return parametrosDePlanejamentoPage.validaCadastro();}

    public String confirmaCadastro(){return parametrosDePlanejamentoPage.confirmaCadastro();}

    public String confirmarCadastro(){return parametrosDePlanejamentoPage.confirmarCadastro();}

    public String validarCadastro(){return  parametrosDePlanejamentoPage.validarCadastro();}

    public void grupoDeOperadores(){parametrosDePlanejamentoPage.grupoDeOperadores();}

    public String validaGrupoAlteraReqServico(){return parametrosDePlanejamentoPage.retornaGrupoReqServico();}
    public String validaGrupoAlteraReqExtra(){return parametrosDePlanejamentoPage.retornaGrupoReqExtra();}
    public String validaGrupoReceitaPadrao(){return parametrosDePlanejamentoPage.retornaGrupoReceitaPadrao();}
    public String validaGrupoAlteraReceitaRevisada(){return parametrosDePlanejamentoPage.retornaGrupoReceitaRevisada();}
    public String validaGrupoGravaDtRefCusto(){return parametrosDePlanejamentoPage.retornaGrupoDtRefCusto();}
    public String validaGrupoGravaDtRefRecalculoCusto(){return parametrosDePlanejamentoPage.retornaGrupoDtRefRecalculoCusto();}
    public String validaGrupoLiberaCardForaMeta(){return parametrosDePlanejamentoPage.retornaGrupoLiberaCardForaMeta();}
    public String validaGrupoAlteraCustoPadrao(){return parametrosDePlanejamentoPage.retornaGrupoCustoPadrao();}
    public String validaGrupoLiberaCardapioDescMatriz(){return parametrosDePlanejamentoPage.retornaGrupoCardDescentralizado();}
    public String validaGrupoAutorizaSubsPratoLiberadoProd(){return parametrosDePlanejamentoPage.retornaGrupoSubstPratoCardLiberadoProducao();}
    public String validaGrupoAcessoOtimizador(){return parametrosDePlanejamentoPage.retornaGrupoAcessoOtimizador();}

    public void cadastraAvisoCardapio(){parametrosDePlanejamentoPage.avisosAprovacaoCardapio();}

    public String retornaDiasAviso(){return parametrosDePlanejamentoPage.validaCadastroDiasAviso();}

    public String retornaCadastroMensagem(){return parametrosDePlanejamentoPage.validarCadastroMensagemAviso();}

    public String retornarCadastroDiasAviso(){return parametrosDePlanejamentoPage.validarCadastroDiasAviso();}

    public String retornarCadastroMensagem(){return parametrosDePlanejamentoPage.validaCadastroMensagemAviso();}

    public void editarMensagemAviso(){parametrosDePlanejamentoPage.editarMensagemAviso();}

    public String confirmaEdicaoMensagem(){return parametrosDePlanejamentoPage.validaEdicaoMensagem();}

    public String confirmarEdicaoMensagem(){return parametrosDePlanejamentoPage.confirmaEdicaoMensagem();}

    public void excluirMensagemAvisoCardapio(){parametrosDePlanejamentoPage.apagarMensagemAviso();}

    public void cadastraAvaliacaoVet(){parametrosDePlanejamentoPage.cadastraAvaliacaoVet();}

    public String validaCadastroDesc(){return parametrosDePlanejamentoPage.retornaDesVet();}

    public String validaCadastroCho(){return parametrosDePlanejamentoPage.retornaVlrCho();}

    public String validaCadastroPtn(){return parametrosDePlanejamentoPage.retornaVlrPtn();}

    public String validaCadastroLip(){return parametrosDePlanejamentoPage.retornaVlrLip();}

    public String validarCadastroDesc(){return parametrosDePlanejamentoPage.retornarDesVet();}

    public String validarCadastroCho(){return parametrosDePlanejamentoPage.retornarVlrCho();}

    public String validarCadastroPtn(){return parametrosDePlanejamentoPage.retornarVlrPtn();}

    public String validarCadastroLip(){return parametrosDePlanejamentoPage.retornarVlrLip();}

    public void editarAvaliacaoVet(){parametrosDePlanejamentoPage.editarAvaliacaoVet();}

    public String retornarDescAtual(){return parametrosDePlanejamentoPage.retornaDescAtu();}
    public String retornarDescAtu(){return parametrosDePlanejamentoPage.retornarDescAtu();}
    public String retornaValChoAtu(){return parametrosDePlanejamentoPage.vlrChoAtu();}
    public String retornaValPtnAtu(){return parametrosDePlanejamentoPage.vlrPtnAtu();}
    public String retornaValLipAtu(){return parametrosDePlanejamentoPage.vlrLipAtu();}
    public String retornarVlrChoAtu(){return parametrosDePlanejamentoPage.valChoAtu();}
    public String retornarVlrPtnAtu(){return parametrosDePlanejamentoPage.valPtnAtu();}
    public String retornarVlrLipAtu(){return parametrosDePlanejamentoPage.valLipAtu();}

    public void excluirAvaliacaoVet(){parametrosDePlanejamentoPage.apagarAvaliacaoVet();}

}
