package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class RelacaoProdutoXEmbalagemPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaRelacaoProdutoXEmbalagem = By.xpath("//span[text() = 'Relação Produto x Embalagem']");

    By abaProdutoPorEmbalagem = By.xpath("//section[@data-zh-id=\"13497457852227765001326\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Produto por Embalagem']");
    By abaEmbalagemPorProduto = By.xpath("//section[@data-zh-id=\"13497457852227765001326\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Embalagem por Produto']");

    //embalagens da aba produto por embalagem
    By vidroAbaProdutoPorEmb = By.xpath("//div[@id=\"grid-134974578528448868471805\"]//div[@data-zh-field-name=\"NMCONTAINER\"]//span[text() = 'VIDRO']");
    By marmitexAbaProdutoPorEmb = By.xpath("//div[@id=\"grid-134974578528448868471805\"]//div[@data-zh-field-name=\"NMCONTAINER\"]//span[text() = 'MARMITÉX']");
    By panelaAbaProdutoPorEmb = By.xpath("//div[@id=\"grid-134974578528448868471805\"]//div[@data-zh-field-name=\"NMCONTAINER\"]//span[text() = 'PANELA']");
    By poteDescartavelAbaProdutoPorEmb = By.xpath("//div[@id=\"grid-134974578528448868471805\"]//div[@data-zh-field-name=\"NMCONTAINER\"]//span[text() = 'POTE DESCARTÁVEL']");
    By plasticoAbaProdutoPorEmb = By.xpath("//div[@id=\"grid-134974578528448868471805\"]//div[@data-zh-field-name=\"NMCONTAINER\"]//span[text() = 'PLÁSTICO']");
    By madeiraAbaProdutoPorEmb = By.xpath("//div[@id=\"grid-134974578528448868471805\"]//div[@data-zh-field-name=\"NMCONTAINER\"]//span[text() = 'MADEIRA']");

    By capacidadeAbaProdutoPorEmbLinha1 = By.xpath("//div[@id=\"grid-134974578528448868471805\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTCONTAINER\"]/span");

    By checkBoxTodosProdutosDaEmbalagem = By.xpath("//div[@id=\"grid-134974578513538254271806\"]//div[@class=\"header-content\"]//div[@data-zh-field-name=\"__CHECKBOX\"]");

    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//div[@class=\"zh-test-box\"]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]//div[@class=\"zh-test-box\"]");
    By botaoCampoProduto = By.xpath("//div[@id=\"NMPRODUTO\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoSalvarAlteracoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoCadAutomatico = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoOkEmbalagemCadAuto = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoConfirmarCadAuto = By.xpath("//div[@class=\"zh-footer-center\"]/ul/li");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//footer[@class=\"zh-footer-alert\"]/button");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");

    //produtos no grid para adicionar um produto à uma embalagem
    By produtoOleoCastanhaDoBrasiladdProduto = By.xpath("//div[@id=\"grid-9000\"]//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'OLEO DE CASTANHA DO BRASIL']");
    By produtoOleoDeCopaibaAddProduto = By.xpath("//div[@id=\"grid-9000\"]//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'OLEO DE COPAIBA']");
    By produtoGrafiteAddProduto = By.xpath("//div[@id=\"grid-9000\"]//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'GRAFITE']");

    By campoQuantProduto = By.id("VRQTDEPRODEMB");
    By campoEmbalagem = By.id("NMCONTAINER");
    By embalagemPanelaAddEmb = By.xpath("//div[@data-zh-id=\"134974578535230273941843\"]//span[text() = '00008 | PANELA']");
    By embalagemVidroAddEmb = By.xpath("//div[@data-zh-id=\"134974578535230273941843\"]//span[text() = '00002 | VIDRO']");
    By campoCapacidade = By.id("VRQTDEPRODEMB");

    By embalagemCheckBoxProdLinha1 = By.xpath("//div[@id=\"grid-134974578513538254271806\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By embalagemCodigoProdLinha1 = By.xpath("//div[@id=\"grid-134974578513538254271806\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By embalagemNomeProdLinha1 = By.xpath("//div[@id=\"grid-134974578513538254271806\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");
    By embalagemUnidadeProdLinha1 = By.xpath("//div[@id=\"grid-134974578513538254271806\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By embalagemQuantidadeProdLinha1 = By.xpath("//div[@id=\"grid-134974578513538254271806\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"VRQTDEPRODEMB\"]/span");

    //produto na aba embalagem por produto
    By oleoCopaibaAbaEmbProProduto = By.xpath("//div[@id=\"grid-134974578524206594391839\"]//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'OLEO DE COPAIBA']");
    By bissulfatoDePostassioAbaEmbProProduto = By.xpath("//div[@id=\"grid-134974578524206594391839\"]//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'BISSULFATO DE POTASSIO']");
    By iodetoDeArsenioAbaEmbProProduto = By.xpath("//div[@id=\"grid-134974578524206594391839\"]//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'IODETO DE ARSENIO']");
    By oxidoCalcioAbaEmbProProduto = By.xpath("//div[@id=\"grid-134974578524206594391839\"]//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'OXIDO DE CALCIO']");
    By nitratoDePratoAbaEmbPorProduto = By.xpath("//div[@id=\"grid-134974578524206594391839\"]//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'NITRATO DE PRATA']");

    By produtoCheckBoxEmbLinha1 = By.xpath("//div[@id=\"grid-134974578525212096141840\"]//div[@class=\"body-content\"]//div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By produtoCodigoEmbLinha1 = By.xpath("//div[@id=\"grid-134974578525212096141840\"]//div[@class=\"body-content\"]//div[1]//div[@data-zh-field-name=\"CDCONTAINER\"]/span");
    By produtoNomeEmbLinha1 = By.xpath("//div[@id=\"grid-134974578525212096141840\"]//div[@class=\"body-content\"]//div[1]//div[@data-zh-field-name=\"NMCONTAINER\"]/span");
    By produtoCapacidadeEmbLinha1 = By.xpath("//div[@id=\"grid-134974578525212096141840\"]//div[@class=\"body-content\"]//div[1]//div[@data-zh-field-name=\"VRQTDEPRODEMB\"]/span");

    By mensagemCantoSuperiorDireito = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");
    By mensagemObrigatorioProdutoInicial = By.xpath("//div[@data-zh-id=\"61639879716959176551786\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProdutoFinal = By.xpath("//div[@data-zh-id=\"6163987974146933531791\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioEmbalagemCadAuto = By.xpath("//div[@data-zh-id=\"6163987977490768761796\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProduto = By.xpath("//div[@data-zh-id=\"134974578525246112081810\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantidadeProd = By.xpath("//div[@data-zh-id=\"134974578531250182901815\"]//div[@class=\"zh-validation\"]/span[1]");
    By mensagemObrigatorioEmbalagem = By.xpath("//div[@data-zh-id=\"134974578535230273941843\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioCapacidade = By.xpath("//div[@data-zh-id=\"134974578541351968921846\"]//div[@class=\"zh-validation\"]/span[1]");
    By mensagemCapacidadeValorMinimo = By.xpath("//div[@data-zh-id=\"134974578541351968921846\"]//div[@class=\"zh-validation\"]/span[2]");
    By mensagemQuantValorMinimo = By.xpath("//div[@data-zh-id=\"134974578531250182901815\"]//div[@class=\"zh-validation\"]/span[2]");
    By mensagemNaoHaRegistroEmbNoProduto = By.xpath("//div[@id=\"grid-134974578525212096141840\"]//div[@class=\"body-content\"]/div[1]//p");
    By mensagemNaoHaRegistroProdNaEmbalagem = By.xpath("//div[@id=\"grid-134974578513538254271806\"]//div[@class=\"body-content\"]/div[1]//p");

    By botaoProdutoInicialCadAuto = By.xpath("//div[@id=\"NMPRODUTOI\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoProdutoFinalCadAuto = By.xpath("//div[@id=\"NMPRODUTOF\"]//span[@style=\"background-image: none; display: block;\"]");
    By produtoIniCadAuto = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CREOSOTO']");
    By produtoFinCadAuto = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'OLEO DE COPAIBA']");
    By embalagemMadeiraCadAuto = By.xpath("//div[@data-zh-field-name=\"NMCONTAINER\"]//span[text() = 'MADEIRA']");
    By checkBoxEmbalagemPorproduto1 = By.xpath("//div[@id=\"grid-61639879723853282361772\"]//div[@class=\"body-content\"]/div[1]/div[1]");
    By checkBoxEmbalagemPorproduto2 = By.xpath("//div[@id=\"grid-61639879723853282361772\"]//div[@class=\"body-content\"]/div[2]/div[1]");

    By botaoAbrirOpcoesControleTelaInicial = By.xpath("//div[@data-ng-if=\"widget.isFloatingControlVisible()\"]//div[@data-zh-floating-control]");
    By botaoPesquisarFiltro = By.xpath("//div[@class=\"control-menu\"]//li[@data-zh-id=\"zh-floating-control-custom-action-1\"]");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");


    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Relação Produto x Embalagem");
        click(opcaoTelaRelacaoProdutoXEmbalagem);
    }


    /////////////
    public void addProdutoNaEmbalagemMarmitex() {
        preencherCampoProcurarTelaInicial("MARMITÉX");
        click(marmitexAbaProdutoPorEmb);
        click(botaoAdicionar);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "101110100300");
        click(produtoOleoDeCopaibaAddProduto);
        sendKeys(campoQuantProduto, "3");
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de salvo com sucesso exibida no canto da tela após adicionar um produto à embalagem");
    }

    public void conferirProdutoAddNaEmbalagem() {
        //valores esperados na tela da embalagem, para produto que foi adicionado na embalagem
        String expCodigoProduto = "1.01.1.1.01.003.00";
        String expNomeProduto = "OLEO DE COPAIBA";
        String expUnidadeProduto = "L";
        String expQuantProduto = "3,00000";

        //valores encontrados na tela da embalagem, do produto que foi adicionado na embalagem
        String encCodigoProduto = getText(embalagemCodigoProdLinha1);
        String encNomeProduto = getText(embalagemNomeProdLinha1);
        String encUnidadeProduto = getText(embalagemUnidadeProdLinha1);
        String encQuantProduto = getText(embalagemQuantidadeProdLinha1);
        Assert.assertEquals(encCodigoProduto, expCodigoProduto, "Verificação código do produto adicionado na tela da embalagem");
        Assert.assertEquals(encNomeProduto, expNomeProduto, "Verificação nome do produto adicionado na tela da embalagem");
        Assert.assertEquals(encUnidadeProduto, expUnidadeProduto, "Verificação unidade do produto adicionado na tela da embalagem");
        Assert.assertEquals(encQuantProduto, expQuantProduto, "Verificação quantidade do produto adicionado na tela da embalagem");
        click(botaoVoltar);


        //acessar o produto para verificar se as informações da embalagem foram adicionadas corretamente
        click(abaEmbalagemPorProduto);
        preencherCampoProcurarTelaInicial("101110100300");
        click(oleoCopaibaAbaEmbProProduto);

        //valores esperados para a embalagem
        String expCodigoEmbalagem = "00007";
        String expNomeEmbalagem = "MARMITÉX";
        String expCapacidadeEmbalagem = "3,00000";

        //valores encontrados
        String encCodigoEmbalagem = getText(produtoCodigoEmbLinha1);
        String encNomeEmbalagem = getText(produtoNomeEmbLinha1);
        String encCapacidadeEmbalagem = getText(produtoCapacidadeEmbLinha1);
        Assert.assertEquals(encCodigoEmbalagem, expCodigoEmbalagem, "Verificar código da embalagem encontrado no produto");
        Assert.assertEquals(encNomeEmbalagem, expNomeEmbalagem, "Verificar nome da embalagem encontrado no produto");
        Assert.assertEquals(encCapacidadeEmbalagem, expCapacidadeEmbalagem, "Verificar capacidade da embalagem encontrado no produto");
    }

    public void excluirEmbalagemAbaEmbPorProduto() {
        click(produtoCheckBoxEmbLinha1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir uma embalagem do produto");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de excluído com sucesso exibida no canto da tela após excluir a embalagem do produto");

        mensagem = getText(mensagemNaoHaRegistroEmbNoProduto);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de não há registro, exibida no grid da lista de embalagens do produto, após a exclusão da embalagem");

        click(botaoVoltar);
        click(abaProdutoPorEmbalagem);
        preencherCampoProcurarTelaInicial("MARMITÉX");
        click(marmitexAbaProdutoPorEmb);
        mensagem = getText(mensagemNaoHaRegistroProdNaEmbalagem);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de não há registro, exibida no grid da lista de produtos da embalagem, após a exclusão da embalagem no produto");
    }

    public void editarQuantidadeProduto(String quantidade) {
        click(abaProdutoPorEmbalagem);
        preencherCampoProcurarTelaInicial("POTE DESCARTÁVEL");
        click(poteDescartavelAbaProdutoPorEmb);
        alterarValor(embalagemQuantidadeProdLinha1, quantidade);
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de salvo com sucesso exibida no canto superior direito da tela, após alterar a quantidade do produto");

        String quantidadeProduto = getText(embalagemQuantidadeProdLinha1);
        Assert.assertEquals(quantidadeProduto, quantidade, "Verificar quantidade do produto após alteração");
        click(botaoVoltar);

        //acessar o produto para verificar se a capacidade da embalagem foi alterada corretamente
        click(abaEmbalagemPorProduto);
        preencherCampoProcurarTelaInicial("101110201400");
        click(iodetoDeArsenioAbaEmbProProduto);

        String capacidadeEmbalagem = getText(produtoCapacidadeEmbLinha1);
        Assert.assertEquals(capacidadeEmbalagem, quantidade, "Verificar se após alterar a quantidade do produto na embalagem, a capacidade da embalagem no produto também foi alterada corretamente");
        click(botaoVoltar);
    }


    /////////////
    public void addEmbalagemNoProdutoBissulfatoPotassio() {
        click(abaEmbalagemPorProduto);
        preencherCampoProcurarTelaInicial("101110200500");
        click(bissulfatoDePostassioAbaEmbProProduto);
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoEmbalagem, embalagemPanelaAddEmb);
        sendKeys(campoCapacidade, "7");
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de salvo com sucesso exibida no canto superior direito da tela, após adicionar uma embalagem à um produto");
    }

    public void conferirEmbalagemAddNoProduto() {
        //verificar na tela do produto, os valores esperados para a embalagem adicionada no produto
        String expCodigoEmbalagem = "00008";
        String expNomeEmbalagem = "PANELA";
        String expCapacidadeEmbalagem = "7,00000";

        //verificar na tela do produto, os valores encontrados para a embalagem adicionada no produto
        String encCodigoEmbalagem = getText(produtoCodigoEmbLinha1);
        String encNomeEmbalagem = getText(produtoNomeEmbLinha1);
        String encCapacidadeEmbalagem = getText(produtoCapacidadeEmbLinha1);
        Assert.assertEquals(encCodigoEmbalagem, expCodigoEmbalagem, "Verificar código da embalagem adicionada no produto");
        Assert.assertEquals(encNomeEmbalagem, expNomeEmbalagem, "Verificar nome da embalagem adicionada no produto");
        Assert.assertEquals(encCapacidadeEmbalagem, expCapacidadeEmbalagem, "Verificar capacidade da embalagem adicionada no produto");
        click(botaoVoltar);


        //acessar a embalagem para verificar se as informações do produto foram adicionadas corretamente
        click(abaProdutoPorEmbalagem);
        preencherCampoProcurarTelaInicial("PANELA");
        click(panelaAbaProdutoPorEmb);

        //valores esperados do produto na tela da embalagem. Para a embalagem que foi adicionada ao prato
        String expCodigoProduto = "1.01.1.1.02.005.00";
        String expNomeProduto = "BISSULFATO DE POTASSIO";
        String expUnidadeProduto = "KG";
        String expQuantProduto = "7,00000";

        //valores encontrados do produto na tela da embalagem. Para a embalagem que foi adicionada ao prato
        String encCodigoProduto = getText(embalagemCodigoProdLinha1);
        String encNomeProduto = getText(embalagemNomeProdLinha1);
        String encUnidadeProduto = getText(embalagemUnidadeProdLinha1);
        String encQuantProduto = getText(embalagemQuantidadeProdLinha1);
        Assert.assertEquals(encCodigoProduto, expCodigoProduto, "Verificar código do produto na tela da embalagem");
        Assert.assertEquals(encNomeProduto, expNomeProduto, "Verificar nome do produto na tela da embalagem");
        Assert.assertEquals(encUnidadeProduto, expUnidadeProduto, "Verificar unidade do produto na tela da embalagem");
        Assert.assertEquals(encQuantProduto, expQuantProduto, "Verificar quantidade do produto na tela da embalagem");
    }

    public void excluirProdutoAbaProdPorEmbalagem() {
        click(embalagemCheckBoxProdLinha1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir o produto da embalagem");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de excluído com sucesso exibida no canto superior direito da tela, após a exclusão do produto");

        mensagem = getText(mensagemNaoHaRegistroProdNaEmbalagem);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de não há registro, exibida no grid da lista de produtos da embalagem, após a exclusão do produto");

        click(botaoVoltar);
        click(abaEmbalagemPorProduto);
        preencherCampoProcurarTelaInicial("101110200500");
        click(bissulfatoDePostassioAbaEmbProProduto);
        mensagem = getText(mensagemNaoHaRegistroEmbNoProduto);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de não há registro, exibida no grid da lista de embalagens do produto, após a exclusão da embalagem");

    }

    public void editarCapacidadeEmbalagemNoProduto(String capacidade) {
        click(abaEmbalagemPorProduto);
        preencherCampoProcurarTelaInicial("101110202100");
        click(oxidoCalcioAbaEmbProProduto);
        alterarValor(produtoCapacidadeEmbLinha1, capacidade);
        tempo();
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem salvo com sucesso exibida no canto superior direito da tela, após alterar a capacidade da embalagem");

        String capacidadeEmb = getText(produtoCapacidadeEmbLinha1);
        Assert.assertEquals(capacidadeEmb, capacidade, "Verificar se a capacidade da embalagem foi alterada corretamente");
        click(botaoVoltar);

        //acessar a embalagem para verificar se a quantidade do produto também foi alterada
        click(abaProdutoPorEmbalagem);
        preencherCampoProcurarTelaInicial("PLÁSTICO");
        click(plasticoAbaProdutoPorEmb);
        String quantProduto = getText(embalagemQuantidadeProdLinha1);
        Assert.assertEquals(quantProduto, capacidade, "Verificar se após alterar a capacidade da embalagem no produto, a quantidade do produto na embalagem também foi alterada corretamente");
        click(botaoVoltar);
    }


    ////////////
    public void verificarCamposObrigatoriosAddEmbalagemNoProd() {
        click(abaEmbalagemPorProduto);
        click(oleoCopaibaAbaEmbProProduto);
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        String embalagem = getText(mensagemObrigatorioEmbalagem);
        String capacidade = getText(mensagemObrigatorioCapacidade);
        String capacidadeValorMin = getText(mensagemCapacidadeValorMinimo);
        String mensagemObrigatorio = "Campo obrigatório";
        String minimoCapacidade = "Minimum value: 0";

        Assert.assertEquals(embalagem, mensagemObrigatorio, "Verificar mensagem de campo obrigatório no campo embalagem, para adicionar uma embalagem à um produto");
        Assert.assertEquals(capacidade, mensagemObrigatorio, "Verificar mensagem de campo obrigatório no campo apacidade, para adicionar uma embalagem à um produto");
        Assert.assertEquals(capacidadeValorMin, minimoCapacidade, "Verificar mensagem quantidade mínima de capacidade no campo capacidade, para adicionar uma embalagem à um produto");

        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }

    public void verificarCamposObrigatoriosAddProdutoNaEmb() {
        click(marmitexAbaProdutoPorEmb);
        click(botaoAdicionar);
        click(botaoSalvar);

        String produto = getText(mensagemObrigatorioProduto);
        String quantidade = getText(mensagemObrigatorioQuantidadeProd);
        String quantValorMin = getText(mensagemQuantValorMinimo);
        String mensagemObrigatorio = "Campo obrigatório";
        String minimoQuantidade = "Minimum value: 0";

        Assert.assertEquals(produto, mensagemObrigatorio, "Verificar mensagem de campo obrigatório no campo produto, para adicionar um produto à embalagem");
        Assert.assertEquals(quantidade, mensagemObrigatorio, "Verificar mensagem de campo obrigatório no campo quantidade, para adicionar um produto à embalagem");
        Assert.assertEquals(quantValorMin, minimoQuantidade, "Verificar mensagem de quantidade minima para adicionar um produto à embalagem");

        click(botaoCancelar);
        click(botaoVoltar);
    }

    public void verificarCamposObrigatoriosCadAuto() {
        tempo();
        click(botaoCadAutomatico);
        tempo();
        click(botaoProdutoInicialCadAuto);
        sendKeys(campoProcurar, "101110100100");
        click(produtoIniCadAuto);
        tempo();
        click(botaoProdutoInicialCadAuto);

        String produtoInicial = getText(mensagemObrigatorioProdutoInicial);
        String produtoFinal = getText(mensagemObrigatorioProdutoFinal);
        String embalagem = getText(mensagemObrigatorioEmbalagemCadAuto);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(produtoInicial, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo produto inicial");
        Assert.assertEquals(produtoFinal, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo produto final");
        Assert.assertEquals(embalagem, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo embalagem");
        click(botaoVoltar);
    }


    ////////////
    public void tentarAddProdutoJaExistenteNaEmb() {
        preencherCampoProcurarTelaInicial("VIDRO");
        click(vidroAbaProdutoPorEmb);
        click(botaoAdicionar);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "101110201300");
        click(produtoGrafiteAddProduto);
        sendKeys(campoQuantProduto, "7");
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela informando que registro já existe na embalagem");
        click(botaoOkAlerta);
        tempo();
        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
        tempo();
    }

    public void tentarAddEmbalagemJaExistenteNoProd() {
        click(abaEmbalagemPorProduto);
        preencherCampoProcurarTelaInicial("101110201800");
        click(nitratoDePratoAbaEmbPorProduto);
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoEmbalagem, embalagemVidroAddEmb);
        sendKeys(campoCapacidade, "3,5");
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela informando que registro já existe no produto");
        click(botaoOkAlerta);
        tempo();
        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
        tempo();
    }


    ////////////
    public void addProdutoAEmbalagemParaTestCadAuto() {
        preencherCampoProcurarTelaInicial("MADEIRA");
        click(madeiraAbaProdutoPorEmb);
        click(botaoAdicionar);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "101110100300");
        click(produtoOleoDeCopaibaAddProduto);
        sendKeys(campoQuantProduto, "5");
        click(botaoSalvar);

        tempo();
        click(botaoAdicionar);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "101110100200");
        click(produtoOleoCastanhaDoBrasiladdProduto);
        sendKeys(campoQuantProduto, "3");
        click(botaoSalvar);
        tempo();
        click(botaoVoltar);
    }

    public void cadastroAuto() {
        Actions actions = new Actions(driver);
        preencherCampoProcurarTelaInicial("MADEIRA");
        tempo();
        String capacidadeMadeira = getText(capacidadeAbaProdutoPorEmbLinha1);

        click(botaoCadAutomatico);
        click(botaoProdutoInicialCadAuto);
        sendKeys(campoProcurar, "101110100100");
        click(produtoIniCadAuto);
        tempo();

        actions.moveToElement(driver.findElement(botaoProdutoFinalCadAuto), 0, 10).click().build().perform();
        sendKeys(campoProcurar, "101110100300");
        click(produtoFinCadAuto);
        tempo();

        actions.moveToElement(driver.findElement(campoEmbalagem), 0, 10).click().build().perform();
        click(embalagemMadeiraCadAuto);
        click(botaoOkEmbalagemCadAuto);
        verificarQuantProdGridEmbalagensPorProd();
        verificarEmbalagemPorProduto(capacidadeMadeira);

        click(checkBoxEmbalagemPorproduto1);
        click(checkBoxEmbalagemPorproduto2);
        click(botaoConfirmarCadAuto);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Produto(s) já associado(s) terá(ão) a quantidade atualizada. Deseja continuar?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de alerta que é exibida na tela após clicar para confirmar o cadastro automático");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Cadastro realizado com sucesso";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem que é exibida no canto superior direito após clicar em sim para realizar o cadastro automático");
        click(botaoVoltar);

        verificarCadastroAuto(capacidadeMadeira);
    }

    public void excluirTodosProdutosDaEmbalagem() {
        click(checkBoxTodosProdutosDaEmbalagem);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir todos os produtos da embalagem");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após a exclusão de todos os produtos");
    }

    private void verificarQuantProdGridEmbalagensPorProd() {
        tempo();
        String quantProdutos = javaScriptExecutor.executeScript("return document.querySelector(\"#grid-61639879723853282361772 > div.body > div\").childElementCount").toString();
        Assert.assertEquals(quantProdutos, "3", "Verificar se a quantidade de produtos encontrados no grid de Embalagens por Produtos, corresponde a quantidade presente no intervalor do produto inicial e final do cad. auto");
    }

    private void verificarEmbalagemPorProduto(String capacidadeEmbalagem) {
        //produtos esperados
        List<String> produtos = new ArrayList<>();
        produtos.add("CREOSOTO");
        produtos.add("OLEO DE CASTANHA DO BRASIL");
        produtos.add("OLEO DE COPAIBA");

        int linhaDoGrid = 1;
        for (String produto : produtos) {
            int colunaCodigo = 2;
            int colunaProduto = 3;
            int colunaUnidade = 4;
            int colunaEmbalagem = 5;
            int colunaQuantidade = 6;

            By codigoProduto = By.xpath("//div[@id=\"grid-61639879723853282361772\"]//div[@class=\"body-content\"]/div[" + linhaDoGrid + "]/div[" + colunaCodigo + "]/span");
            By nomeProduto = By.xpath("//div[@id=\"grid-61639879723853282361772\"]//div[@class=\"body-content\"]/div[" + linhaDoGrid + "]/div[" + colunaProduto + "]/span");
            By unidadeProduto = By.xpath("//div[@id=\"grid-61639879723853282361772\"]//div[@class=\"body-content\"]/div[" + linhaDoGrid + "]/div[" + colunaUnidade + "]/span");
            By nomeEmbalagem = By.xpath("//div[@id=\"grid-61639879723853282361772\"]//div[@class=\"body-content\"]/div[" + linhaDoGrid + "]/div[" + colunaEmbalagem + "]/span");
            By quantidadeEmbalagem = By.xpath("//div[@id=\"grid-61639879723853282361772\"]//div[@class=\"body-content\"]/div[" + linhaDoGrid + "]/div[" + colunaQuantidade + "]/span");

            //valores esperados
            String expCodigo = "1.01.1.1.01.00" + linhaDoGrid + ".00";
            String expUnidade = "L";
            String expEmbalagem = "MADEIRA";

            //valores encontrados
            String encCodigo = getText(codigoProduto);
            String encNomeProduto = getText(nomeProduto);
            String encUnidadeProduto = getText(unidadeProduto);
            String encNomeEmbalagem = getText(nomeEmbalagem);
            String encQuantEmbalagem = getText(quantidadeEmbalagem);

            Assert.assertEquals(encCodigo, expCodigo, "Verificar se o código do produto na linha " + linhaDoGrid + " faz parte dos códigos presentes no intervalo do produto inicial e final");
            Assert.assertEquals(encNomeProduto, produto, "Verificar se o nome do produto na linha " + linhaDoGrid + " faz parte dos nomes presentes no intervalo do produto inicial e final");
            Assert.assertEquals(encUnidadeProduto, expUnidade, "Verificar a unidade do produto na linha " + linhaDoGrid + " corresponde à unidade esperada");
            Assert.assertEquals(encNomeEmbalagem, expEmbalagem, "Verificar o nome da embalagem na linha " + linhaDoGrid + " embalagem esperada");
            Assert.assertEquals(encQuantEmbalagem, capacidadeEmbalagem, "Verificar o nome a quantidade da embalagem na linha " + linhaDoGrid + " à capacidade da emabalagem selecionada");

            linhaDoGrid += 1;
        }
    }

    private void verificarCadastroAuto(String capacidade) {
        click(madeiraAbaProdutoPorEmb);
        tempo();
        String quantProdutos = javaScriptExecutor.executeScript("return document.querySelector(\"#grid-134974578513538254271806 > div.body > div\").childElementCount").toString();
        Assert.assertEquals(quantProdutos, "3", "Verificar quantidade de produtos na embalagem após o cadastro automático");

        //produtos esperados
        List<String> produtos = new ArrayList<>();
        produtos.add("CREOSOTO");
        produtos.add("OLEO DE CASTANHA DO BRASIL");
        produtos.add("OLEO DE COPAIBA");

        int linhaDoGrid = 1;
        for (String produto : produtos) {
            int colunaCodigo = 2;
            int colunaProduto = 3;
            int colunaUnidade = 4;
            int colunaQuantidade = 5;

            By codigoProduto = By.xpath("//div[@id=\"grid-134974578513538254271806\"]//div[@class=\"body-content\"]/div[" + linhaDoGrid + "]/div[" + colunaCodigo + "]/span");
            By nomeProduto = By.xpath("//div[@id=\"grid-134974578513538254271806\"]//div[@class=\"body-content\"]/div[" + linhaDoGrid + "]/div[" + colunaProduto + "]/span");
            By unidadeProduto = By.xpath("//div[@id=\"grid-134974578513538254271806\"]//div[@class=\"body-content\"]/div[" + linhaDoGrid + "]/div[" + colunaUnidade + "]/span");
            By quantidadeProduto = By.xpath("//div[@id=\"grid-134974578513538254271806\"]//div[@class=\"body-content\"]/div[" + linhaDoGrid + "]/div[" + colunaQuantidade + "]/span");

            //valores encontrados
            String encCodigo = getText(codigoProduto);
            String encNomeProduto = getText(nomeProduto);
            String encUnidade = getText(unidadeProduto);
            String encQuantidade = getText(quantidadeProduto);

            if (linhaDoGrid == 3) {
                //valores esperados
                String expCodigo = "1.01.1.1.01.003.00";
                String expNomeProduto = "OLEO DE COPAIBA";
                String expUnidade = "L";
                String expQuantidade = "5,00000";

                Assert.assertEquals(encCodigo, expCodigo, "Verificar se o código do produto que já estava cadastrado antes do cadastro automático não foi alterado");
                Assert.assertEquals(encNomeProduto, expNomeProduto, "Verificar se o nome do produto que já estava cadastrado antes do cadastro automático não foi alterado");
                Assert.assertEquals(encUnidade, expUnidade, "Verificar se a unidade do produto que já estava cadastrado antes do cadastro automático não foi alterado");
                Assert.assertEquals(encQuantidade, expQuantidade, "Verificar se a quantidade do produto que já estava cadastrado antes do cadastro automático não foi alterado");
            } else {
                //valores esperados
                String expCodigo = "1.01.1.1.01.00" + linhaDoGrid + ".00";
                String expUnidade = "L";

                Assert.assertEquals(encCodigo, expCodigo, "Verificar código do produto cadastro automaticamente");
                Assert.assertEquals(encNomeProduto, produto, "Verificar nome do produto cadastro automaticamente");
                Assert.assertEquals(encUnidade, expUnidade, "Verificar unidade do produto cadastro automaticamente");
                Assert.assertEquals(encQuantidade, capacidade, "Verificar quantidade do produto cadastro automaticamente");
            }
            linhaDoGrid += 1;
        }
    }


    ////////////
    private void alterarValor(By campo, String valor) {
        Actions actions = new Actions(driver);
        tempo();
        actions.click(driver.findElement(campo)).build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(valor).build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
    }

    private void preencherCampoProcurarTelaInicial(String texto) {
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        if (returnClassOpened(botaoAbrirOpcoesControleTelaInicial) && !returnClassOpened(botaoPesquisarFiltro)) {
            click(botaoPesquisarFiltro);
        } else if (!returnClassOpened(botaoAbrirOpcoesControleTelaInicial)){
            click(botaoAbrirOpcoesControleTelaInicial);
            tempo();
            click(botaoPesquisarFiltro);
        }
        clearAndSendKeys(campoProcurar, texto);
        tempo();
    }

    private boolean returnClassOpened(By locator) {
        return driver.findElement(locator).getAttribute("className").contains("opened");
    }

}