    package com.javaseleniumtemplate.pages;

    import com.javaseleniumtemplate.bases.PageBase;
    import org.openqa.selenium.By;

    public class CadastroPratoPage extends PageBase {

            By usernameLoginInfoTextArea = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
            By msgConfirmaTela = By.xpath("//div[@class = 'navbar-header']//div[contains(text(),'Prato')]");
            By botaoInicial = By.xpath("//*[@type = 'button']");
            By displayInicio = By.xpath("//*[@type = 'button']");
            By btnParametrizacao = By.xpath("//*[@class = 'menu-link'] //*[contains(text(),'Parametrização')]");

            By clicaPlanejamento = By.xpath("//ul[@class = 'sub-menu']//*[contains(text(),'Planejamento')]");

            By clicaEmPrato = By.xpath("//ul[@class = 'sub-menu']//li[@class = 'menu-item closed sub-menu-item has-child visible']//span[@class = 'menu-link']//*[contains(text(),'Prato')]");
            By telaPrato = By.xpath("//li[@data-zh-id='90884303624417313356731']//span[contains(text(),'Prato')]");

            //Filtro de unidade
            By filtroFilial = By.xpath("//div[@name = 'FILTER_FILIAL']");
            By inputUnidade = By.xpath("//*[@id='popup']//input[@type = 'text']");
            By checkUnidade = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]");

            //Adição de Pratos
            By limpaCdPrato = By.xpath("//input[@id= 'CDPRATO']");
            By addPrato = By.xpath("//li[@data-zh-id='137808569433695534111597']");
            By nmPrato = By.xpath("//*[@id='NMPRATO']");
            By btnSalvar = By.xpath("//*[contains(text(),'Salvar')]");
            By btnAdiciona = By.xpath("//li[@data-zh-id='13780856941114520277755']");
            By filtroUnidade = By.xpath("//div[@id = 'DSUNIDADE']//span[@class = 'zh-icon zh-icon-search zh-icon-no-border']");
            By unidadeMedida = By.xpath("//*[@id='popup']//input[@type = 'text']");
            By abaReceita = By.xpath("//a[contains(text(),'Receita')]");

            //Adiciona Receita Padrão
            By receitaPadrao = By.xpath("//span[contains(text(),'Receita Padrão')]");
            By addRecPadr = By.xpath("//li[@data-zh-id='13780856943627244083845']");
            By produtoReceita = By.xpath("//div[@id = 'NMPRODUTO']//span[@class = 'zh-icon zh-icon-search zh-icon-no-border']");
            By filtraProduto = By.xpath("//*[@id='popup']//input[@type = 'text']");
            By confirProduto = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]");
            By unidadeProduto = By.xpath("//div[@id = 'SGUNIDADEPROD']//span[@class = 'zh-icon zh-icon-search zh-icon-no-border']");
            By qtFixa = By.xpath("//div[@data-zh-id='13780856943979449840819']//span[@class = 'current']");
            By checkQtdFixa = By.xpath("//div[@data-zh-id='13780856943979449840819']//li[contains(text(),'Não')]");
            By qtBruta = By.xpath("//input[@id = 'QTBRUTAPRUNR']");
            By ganhoCoccao = By.xpath("//input[@id = 'VRPEFATCOCPR']");
            By apCoccao = By.xpath("//input[@id = 'VRPEFATCOCPRAP']");
            By perdaLimpeza = By.xpath("//input[@id = 'VRPEFATCORPR']");
            By apLimpeza = By.xpath("//input[@id = 'VRPEFATCORPRAP']");
            By vlrPerdaDegelo = By.xpath("//input[@id = 'VRPERCDEGELO']");
            By reqPara = By.xpath("//div[@data-zh-id='13780856943030116969833']//span[@class = 'current']");
            By defineRequisicao = By.xpath("//li[contains(text(),'Produção')]");
            By qtComplemento = By.xpath("//input[@id = 'QTCOMPLPRODPADR']");
            By complEntrDireta = By.xpath("//div[@data-zh-id='13780856942160705813835']//span[@class = 'current']");
            By Tempo = By.xpath("//input[@id = 'HRTEMPPREPPR']");
            By prBase = By.xpath("//div[@data-zh-id='1378085694452204633837']//span[@class = 'current']");
            By qtLimiteSeguranca = By.xpath("//input[@id = 'QTLIMSEGPADR']");
            By apNutricional = By.xpath("//input[@id = 'VRPEFATNUTPR']");

            //Dados da receita
            By abaDadosReceita = By.xpath("//a[contains(text(),'Dados da Receita')]");
            By btnEditar = By.xpath("//li[@data-zh-id='137808569472104681907']");
            By limpaProdProducao = By.xpath("//div[@id = 'NMPRODUTO']//span[@zh-icon = 'no-border close-x']");
            By buscaProdProducao = By.xpath("//div[@id = 'NMPRODUTO']//span[@zh-icon = 'no-border search']");
            By procuraProdProducao = By.xpath("//*[@id='popup']//input[@type = 'text']");
            By selectProdProducao = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]");
            By boxFinalizacao = By.xpath("//div[@data-zh-id='13780856944094074503890']//span[@class = 'current']");
            By idFinalizacao = By.xpath("//li[contains(text(),'Matriz')]");
            By prodCookChill = By.xpath("//div[@data-zh-id='1378085694511042915891']//span[@class = 'current']");
            By idCookChill = By.xpath("//li[contains(text(),'Não')]");
            By qtdAntecipacao = By.xpath("//input[@id = 'QTLIMSEGPADR']");
            By nmFantasiaPrato = By.xpath("//input[@id = 'NMFANTASIAPR']");
            By corPrato = By.xpath("//div[@id = 'NRCORPRIPRAT']");
            By idCorPrato = By.xpath("//div[@style='background-color: rgb(60, 214, 231);']");
            By idValidade = By.xpath("//input[@id = 'VALIDADE']");
            By idQtdPratoPessoa = By.xpath("//input[@id = 'QTPADRAOPRAT']");

            By clickVoltar = By.xpath("//span[contains(text(),'Voltar')]");

            By btnCalcular = By.xpath("//div[@id = 'span-field-CALCULARQTDPESSO']//button[contains(text(),'Calcular')]");
            By msgAlert = By.xpath("//footer[@class= 'zh-footer-alert']//span[contains(text(),'Sim')]");


            public void clicarMenuPrincipal() {

            tempo();
                click(botaoInicial);
            }

            public void telaPrato(){
                click(btnParametrizacao);
                click(clicaPlanejamento);
                click(clicaEmPrato);
                click(telaPrato);
            }

            public String confirmaTela(){
                return getText(msgConfirmaTela);
            }

            public void filtraFilial(String unidade){
                click(filtroFilial);
                click(inputUnidade);
                sendKeys(inputUnidade,unidade);
                tempo();
                click(checkUnidade);
            }

            public void arvoreDePrato(String nomePrato){
             click(addPrato);
             click(limpaCdPrato);
             clearAndSendKeys(limpaCdPrato,"05");
             for (int i = 0; i < 3; i++){
                click(nmPrato);
                sendKeys(nmPrato, nomePrato);
                click(btnSalvar);
                tempo();
                click(btnAdiciona);


             }

            }

        public void dadosPrato(String nomePrato, String unidadeDeMedida){
                click(nmPrato);
                sendKeys(nmPrato, nomePrato);
                click(filtroUnidade);
                sendKeys(unidadeMedida,unidadeDeMedida);
                tempo();
                click(checkUnidade);
                click(btnSalvar);
                tempo();
                click(abaReceita);

        }

        public void receitaPadrao(String nmProduto, String qtdBruta, String qtdCoccao, String qtdApCoccao, String qtdPerdaLimpesa
        , String qtdApLimpeza, String vlrDegelo, String qtdComplemento, String vlrTempo, String diasSeguranca){

                click(receitaPadrao);
                click(addRecPadr);
                click(produtoReceita);
                sendKeys(filtraProduto,nmProduto);
                tempo();
                click(confirProduto);
                click(qtFixa);
                click(checkQtdFixa);
                click(qtBruta);
                clearAndSendKeys(qtBruta, qtdBruta);
                click(ganhoCoccao);
                clearAndSendKeys(ganhoCoccao,qtdCoccao);
                click(apCoccao);
                clearAndSendKeys(apCoccao, qtdApCoccao);
                click(perdaLimpeza);
                clearAndSendKeys(perdaLimpeza,qtdPerdaLimpesa);
                click(apLimpeza);
                clearAndSendKeys(apLimpeza, qtdApLimpeza);
                click(vlrPerdaDegelo);
                clearAndSendKeys(vlrPerdaDegelo, vlrDegelo);
                click(reqPara);
                click(defineRequisicao);
                click(qtComplemento);
                clearAndSendKeys(qtComplemento, qtdComplemento);
                click(Tempo);
                clearAndSendKeys(Tempo, vlrTempo);
                click(qtLimiteSeguranca);
                clearAndSendKeys(qtLimiteSeguranca,diasSeguranca);
                click(btnSalvar);
                tempo();

        }

            public void receitaPadraoProdutos(String nmProduto, String qtdBruta){
                click(addRecPadr);
                click(produtoReceita);
                sendKeys(filtraProduto,nmProduto);
                tempo();
                click(confirProduto);
                click(qtBruta);
                sendKeys(qtBruta, qtdBruta);
                click(btnSalvar);
                tempo();

            }

            public void dadosDaReceita(String produtoProducao, String nomeFantasia, String validadeConsumo){
                click(abaDadosReceita);
                click(btnEditar);
             //   click(limpaProdProducao);
                click(buscaProdProducao);
                click(procuraProdProducao);
                sendKeys(procuraProdProducao, produtoProducao);

                click(selectProdProducao);
                click(boxFinalizacao);
                click(idFinalizacao);
                click(prodCookChill);
                click(idCookChill);
              //  click(qtdAntecipacao);
                click(nmFantasiaPrato);
                clearAndSendKeys(nmFantasiaPrato, nomeFantasia);
             //   click(corPrato);
              //  click(idCorPrato);
                click(idValidade);
                sendKeys(idValidade,validadeConsumo);
                click(btnSalvar);
                tempo();
                click(clickVoltar);
            }

        // Acessando receita Local

        By btnLevel1 = By.xpath("//div[@class = 'tr zh-row-lvl-1 closed']//span[@class = 'tree-expand-icon closed']");
        By btnLevel2 = By.xpath("//div[@class = 'tr zh-row-lvl-2 closed']//span[@class = 'tree-expand-icon closed']");
        By btnLevel3 = By.xpath("//div[@class = 'tr zh-row-lvl-3 closed']//span[@class = 'tree-expand-icon closed']");

        By clickPrato = By.xpath("//div[@class = 'tr zh-row-lvl-4 closed']//div[@data-zh-field-name= 'CDPRATO']");
        By receitaLocal = By.xpath("//span[contains(text(),'Receita Local')]");
        By clickCampoUnidade = By.xpath("//div[@id = 'NMFILIAL']");
        By selecionaUnidade = By.xpath("//div[@data-zh-id='137808569422286201541090']//span[text()='0002 | DEPOSITO JABAQUARA']");
        By adicionaProdutoLocal = By.xpath("//li[@data-zh-id='13780856941409032400992']");
        By qtFixaLocal = By.xpath("//div[@data-zh-id='13780856942105682773966']/div[2]");
        By checkQtdFixaLocal = By.xpath("//div[@data-zh-id='13780856942105682773966']//li[contains(text(),'Não')]");
        By qtdBruta = By.xpath("//input[@id = 'QTBRUTALOUNR']");
        By ganhoCoccaoLocal = By.xpath("//input[@id = 'VRPEFATCOCLO']");
        By apCoccaoLocal = By.xpath("//input[@id = 'VRPEFATCOCLOAP']");
        By perdaLimpezaLocal = By.xpath("//input[@id = 'VRPEFATCORLO']");
        By apLimpezaLocal = By.xpath("//input[@id = 'VRPEFATCORLOAP']");
        By reqParaLocal = By.xpath("//div[@data-zh-id='13780856941943103655980']//span[@class = 'current']");
        By defineRequisicaoLocal = By.xpath("//li[contains(text(),'Produção')]");
        By complementoLocal = By.xpath("//input[@id = 'QTCOMPLPRODFILI']");
        By complEntrDiretaLocal = By.xpath("//div[@data-zh-id='13780856944284943343982']//span[@class = 'current']");
        By defineCompEntrDireta = By.xpath("//div[@data-zh-id='13780856944284943343982']//li[text() = 'Não']");
        By tempoPraparo = By.xpath("//input[@id = 'HRTEMPPREPLO']");
        By prBaseLocal = By.xpath("//div[@data-zh-id='13780856942154187268984']//span[@class = 'current']");
        By definePrBaseLocal = By.xpath("//div[@data-zh-id='13780856942154187268984']//li[text() = 'Não']");
        By btnSalvarRecLocal = By.xpath("//div[@id = 'footer']//span[text() = 'Salvar']");

        // Excluindo produto receita local

        By produtoReceitaLocal = By.xpath("//div[@id = 'grid-13780856942110675793943']//div[@class = 'tr cell1']//span[text() = 'CREOSOTO']");

        // Aba Dados da Receita Local

        By dadosDaReceitaLocal = By.xpath("//a[text()= 'Dados da Receita']");
        By btnEdicao = By.xpath("//li[@data-zh-id='137808569416586041521055']");
        By clickProdProducao = By.xpath("//div[@id = 'NMPRODUTO']");
        By prodProducao = By.xpath("//div[@id = 'NMPRODUTO']//span[@zh-icon = 'no-border search']");
        By informaProdProducao = By.xpath("//*[@id='popup']//input[@type = 'text']");
        By selecionaProdProducao = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]");
        By comboboxFinalizacao = By.xpath("//div[@data-zh-id='137808569440559525961038']//span[text() = 'Matriz']");
        By checkFinalizacao = By.xpath("//li[contains(text(),'Matriz')]");
        By idProdCookChill = By.xpath("//div[@data-zh-id='13780856942496982491039']//span[@class = 'current']");
        By idCookChillFili = By.xpath("//li[contains(text(),'Não')]");
        By qtdAntecipacaoFili = By.xpath("//input[@id = 'QTLIMSEGFILI']");
        By tpArmazenamento = By.xpath("//div[@data-zh-id='13780856948170518651042']//span[@class = 'current']");
        By armazenamentoFili = By.xpath("//li[text() = 'Congelado']");
        By nmFantasia = By.xpath("//input[@name = 'NMFANTASIAPF']");
        By validadeConsumo = By.xpath("//input[@name = 'VALIDADE']");
        By qtPessoa = By.xpath("//input[@name = 'QTPADRAOFILI']");
        By Status = By.xpath("//div[@data-zh-id='137808569430136696971050']//span[@class = 'current']");
        By idAtivo = By.xpath("//li[text() = 'Ativo']");
        By dsPrato = By.xpath("//*[@id = 'DSPRATO']");
        By btnCalcularQtdPessoa = By.xpath("//button[text()= 'Calcular']");
        By confirQtdPessoa = By.xpath("//button[@type = 'submit']//span[text() = 'Sim']");
        By btnSalva = By.xpath("//span[text() = 'Salvar']");
        By btnCancelar = By.xpath("//span[text() = 'Cancelar']");


        public void filtroPrato(){
                click(btnLevel1);
                click(btnLevel2);
                click(btnLevel3);
                }

                public void receitaLocal(){
                click(clickPrato);
                click(abaReceita);
                click(receitaLocal);
                click(clickCampoUnidade);
                click(selecionaUnidade);
                    tempo();

                }

                public void produtoReceitaLocal(String nmproduto, String qtdeBruta, String ganhoCoccao,
                String apCoccao, String perdaLimpLocal, String degeloLocal, String idTempoPreparo){
                click(adicionaProdutoLocal);
                click(produtoReceita);
                click(filtraProduto);
                clearAndSendKeys(filtraProduto, nmproduto);
                tempo();
                click(confirProduto);
                click(qtFixaLocal);
                click(checkQtdFixaLocal);
                click(qtdBruta);
                clearAndSendKeys(qtdBruta, qtdeBruta);
                click(ganhoCoccaoLocal);
                clearAndSendKeys(ganhoCoccaoLocal, ganhoCoccao);
                click(apCoccaoLocal);
                clearAndSendKeys(apCoccaoLocal, apCoccao);
                click(perdaLimpezaLocal);
                clearAndSendKeys(perdaLimpezaLocal, perdaLimpLocal);
                click(vlrPerdaDegelo);
                clearAndSendKeys(vlrPerdaDegelo, degeloLocal);
                click(reqParaLocal);
                click(defineRequisicaoLocal);
                click(complEntrDiretaLocal);
                click(defineCompEntrDireta);
                click(tempoPraparo);
                clearAndSendKeys(tempoPraparo,idTempoPreparo );
                click(prBaseLocal);
                click(definePrBaseLocal);
                click(btnSalvarRecLocal);
                tempo();
        }
        public void excluirProduto(){
            click(produtoReceitaLocal);
        }


        public void dadosDaReceitaLocal(String CDPRODPRODUCAO, String QTDDIASANTECIPACAO, String NMFANTASIAL,
                                        String DTVALCONSUMO, String QTDPESSOA, String DSPRATO){
            click(dadosDaReceitaLocal);
            click(btnEdicao);
            click(clickProdProducao);
            click(prodProducao);
            click(informaProdProducao);
            sendKeys(informaProdProducao , CDPRODPRODUCAO);
            tempo();
            click(selecionaProdProducao);
            click(comboboxFinalizacao);
            click(checkFinalizacao);
            click(idProdCookChill);
            click(idCookChillFili);
          /*  click(qtdAntecipacaoFili);
            sendKeys(qtdAntecipacaoFili ,QTDDIASANTECIPACAO);
            click(tpArmazenamento);
            click(armazenamentoFili);*/
            click(nmFantasia);
            clearAndSendKeys(nmFantasia, NMFANTASIAL);
            click(validadeConsumo);
            clearAndSendKeys(validadeConsumo , DTVALCONSUMO);
            click(qtPessoa);
            clearAndSendKeys(qtPessoa , QTDPESSOA);
            click(Status);
            click(idAtivo);
            click(dsPrato);
            clearAndSendKeys(dsPrato, DSPRATO);
            click(btnSalva );
            click(btnCalcularQtdPessoa);
            click(confirQtdPessoa);
            tempo();
        }



    }
