package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.HistoricodeAlteracaodeComensaisFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import org.testng.Assert;
import org.testng.annotations.Test;

public class HistoricodeAlteracaodeComensaisTests extends TestBase {

    LoginFlows loginFlows;
    HistoricodeAlteracaodeComensaisFlows historiAlteracao;

    @Test
    public void visualizaHistoricoAlteracao(){
        String NMFILIAL = "0002 - DEPOSITO JABAQUARA";
        loginFlows = new LoginFlows();
        historiAlteracao = new HistoricodeAlteracaodeComensaisFlows();
        loginFlows.efetuarLogin();
        historiAlteracao.acessarTela();
        historiAlteracao.realizarFiltro();
        Assert.assertEquals(historiAlteracao.confirmaFiltro(),NMFILIAL,"Confirma Filial Filtro");
        historiAlteracao.visualizarRegistroAlteracao();

    }


}
